/*
		    P M 4 H P . C
*/

/* Program LASER.C (from simtel:pub/msdos/laser/ljsetup.zip)
 * enlarged by Petr Mikulik (July 1994) [mikulik@sci.muni.cz]
 * to program PM4HP.C.
 *
 * The new features are *mostly* labeled by  +++  or  ---  or  PM
 */



/* now the original header: */
/*
 *			L A S E R . C
 *
 * $Revision:   1.7  $
 *
 * $Log:   E:\usr\ljsetup\vcs\laser.c_v  $
 *
 *    Rev 1.7   13 Aug 1986 10:18:26   bbechtel
 * Corrected to work under MS-DOS with Microsoft 3.0
 *
 *    Rev 1.6   13 Aug 1986  9:51:04   bbechtel
 * Initial revision.
 * Revision 1.5  86/07/14  17:51:09  ron
 * Prepared for distribution
 *
 * Revision 1.4  86/07/14  16:34:19  ron
 * Cleaned up code, generally made more human readable.
 *
 * Revision 1.3  86/07/14  15:05:31  ron
 * Basically re-wrote the whole damned thing to support all, well most
 * of the LaserJet features that are available.  Instead of simply supporting
 * those that were originally used.  The program now supports all of the
 * HP font cartridges with most of the attributes available...
 *
 * Revision 1.2  86/07/14  09:46:30  ron
 * Added distinctive RCS header
 *
 */

#define PRINTERSTATUS
  /* PM+ the definition is very useful on PC computers: it detects
     if the printer is ready */

#define NbFontsDJ 25
  /* number of defined DeskJet fonts */

#ifndef lint
static char RCSid[] = "@(#)$Header:   pm4hp.c   July 1994  Petr  $";
/* old header: static char RCSid[] = "@(#)$Header:   E:\usr\ljsetup\vcs\laser.c_v   1.7   13 Aug 1986 10:18:26   bbechtel  $"; */
#endif

#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <string.h>
#ifdef PRINTERSTATUS
#include <dos.h>
#endif

#define	LPRCMD "/usr/bin/lp 2>/dev/null 2>&1"

/*  If your system can handle it... */
/* #define BIGHELPTEXT		/* ... mine can't */

#define USAGE() fprintf (stdout, ">>>> Type   pm4hp -H | more  or  pm4hp -? | more  to display a help screen.\n")


/* PM+ file GETOPT.C included here */
#ifndef lint
static char rcsid[] = "$Header:   E:\usr\ljsetup\vcs\getopt.c_v   1.0   13 Aug 1986 10:18:52   bbechtel  $";
#endif

/* got this off net.sources */
#include <stdio.h>

/*
 * get option letter from argument vector
 */
int	opterr = 1,	/* if set to zero no message for bad option */
	optind = 1,	/* index into parent argv vector */
	optopt;		/* character checked for validity */
char	*optarg;	/* argument associated with option */

/* ++++ */
int linespage = 72; /* lines per page */
int pmd = -1;  /* direction */
int pmf = -1; /* HPLJ font number */
int pmg = -1; /* HPDJ font number */
int ShowFonts = 0; /* show HPLJ fonts */
int ShowFontsDeskJet = 0; /* show HPDJ fonts */
int PaperFormat = 0; /* default */
int UpperMargin = 0;
int tmpXx = 0;  /* it is needed only locally in X,x options */
int Eject=1;
int BeforeFileReset=1;
int FinalReset=0;
/* ++++--- */

#define BADCH	(int)'?'
#define EMSG	""

getopt(nargc,nargv,ostr)
int	nargc;
char	**nargv,
	*ostr;
{
    static char	*place = EMSG;	/* option letter processing */
    register char	*oli;		/* option letter list index */
/*    char	*strchr(); */

    if(!*place) {			/* update scanning pointer */
	if(optind >= nargc || *(place = nargv[optind]) != '-' || !*++place)
	    return(EOF);
	if (*place == '-') {	/* found "--" */
	    ++optind;
	    return(EOF);
	}
    }				/* option letter okay? */
    if ((optopt = (int)*place++) == (int)':' || !(oli = strchr(ostr,optopt))) {
	if(!*place) ++optind;
	if (opterr)
	    fprintf(stdout, "%s: illegal option -- %c\n", *nargv, optopt);
	return(BADCH);
    }
    if (*++oli != ':') {		/* don't need argument */
	optarg = NULL;
	if (!*place) ++optind;
    }
    else {				/* need an argument */
	if (*place) optarg = place;	/* no white space */
	else if (nargc <= ++optind) {	/* no arg */
	    place = EMSG;
	    if (opterr)
		fprintf(stdout, "%s: option requires an argument -- %c\n",
		    *nargv, optopt);
	    return(BADCH);
	}
	 else optarg = nargv[optind];	/* white space */
	place = EMSG;
	++optind;
    }
    return(optopt);			/* dump back option letter */
}
/* PM- */

void HELP () {
    int NbFontsDJint;
    NbFontsDJint=NbFontsDJ;
    fprintf (stdout, "*** Program pm4hp ***\n");
    fprintf (stdout, "Program pm4hp allows to change setup of many of HP printers (LaserJet, DeskJet).\n");
    fprintf (stdout, "The program as well as its source code in C language is public-domain.\n");
    fprintf (stdout, "From program laser (Aug 1986) by Ron Flax rewritten (July 1994) by Petr Mikulik.\n");
    fprintf (stdout, "A remark by PM: I had to (re)write this program because no such\n");
    fprintf (stdout, "program had been supplied by Hewlett Packard with the HP DeskJet printer.\n");
/*    fprintf (stdout, "Preliminary remark by PM: I had to (re)write this program because no such\n");
    fprintf (stdout, "program had been supplied by Hewlett Packard with the HP DeskJet printer\n");
    fprintf (stdout, "(for PC). If anybody from that company meets this program, I propose them:\n");
    fprintf (stdout, "  1. supply their printers with with such a program (why not with this?)\n");
    fprintf (stdout, "  2. supply their printers with screen hardcopy program for HPDJ color printers.\n");
    fprintf (stdout, "  Also the source codes would be very welcome instead of very brief manual.\n");
*/
    fprintf (stdout, "*** hp Command Options:***\n");
    fprintf (stdout, "  c	--	Character Set\n");
    fprintf (stdout, "    (1)  Roman-8        (2)  USASCII  (3)  Roman Ext. (4)  Danish/Norwegian\n");
    fprintf (stdout, "    (5)  United Kingdom (6)  French   (7)  German     (8)  Italian\n");
    fprintf (stdout, "    (9)  Swedish       (10)  Spanish (11)  Legal     (12)  Linedraw\n");
    fprintf (stdout, "   (13)  Math8         (14)  Math8a  (15)  Math8b    (16)  Math7\n");
    fprintf (stdout, "   (17)  PiFont        (18)  PiFonta\n");
    fprintf (stdout, "  o	--	Orientation (Portrait or Landscape, P or L)\n");
    fprintf (stdout, "  A	--	(0) default  (1) US letter  (2) US legal  (3) US exe  (4) A4\n");
    fprintf (stdout, "   	  	(5) envelope 10  (6) envelope DL\n");
    fprintf (stdout, "  t	--	Typeface\n");
    fprintf (stdout, "    (1)  Courier        (2)  Line Printer   (3)  Helvetica\n");
    fprintf (stdout, "    (4)  Times Roman    (5)  Prestige Elite (6)  Gothic\n");
    fprintf (stdout, "  h	--	Point Size (character height)\n");
    fprintf (stdout, "    (1)  7 Pt. (2)  8 Pt. (3)  8.5 Pt. (4)  10 Pt. (5)  12 Pt. (6)  14.4 Pt.\n");
    fprintf (stdout, "  p	--	Pitch\n");
    fprintf (stdout, "    (1)  10 cpi (2)  12 cpi (3)  16.66 cpi\n");
    fprintf (stdout, "  s	--	Spacing (Proportional or Fixed, P or F)\n");
    fprintf (stdout, "  l	--	Lines per inch ( 1, 2, 3, 4, 6, 8, 12, 16, 24)\n");
    fprintf (stdout, "   	  	Corresponding  (12,24,36,48,72,96,144,192,284) lines/page for\n");
    fprintf (stdout, "   	  	paper long enough (e.g. US legal)\n");
    fprintf (stdout, "  i	--	Italic\n");
    fprintf (stdout, "  b	--	Bold\n");
    fprintf (stdout, "  O	--	Offset from left edge (number of spaces)\n");
    fprintf (stdout, "  P	--	Page Step (number of extra lines)\n");
    fprintf (stdout, "  R	--	Printer reset when the program terminates\n");
    fprintf (stdout, "  r	--	no printer reset before the file is printed\n");
    fprintf (stdout, "  e	--	don't eject paper when the file printing is finished\n");
    fprintf (stdout, "  U	--	Upper margin (number of lines) + increment G by this value\n");
    fprintf (stdout, "  F	--	total number of lines on page \n");
    fprintf (stdout, "  G	--	Page (Forms) Length (number of lines of text on page)\n");
    fprintf (stdout, "  d	--	direction: (1) both  (0) left to right (2) right to left\n");
    fprintf (stdout, "  f	--	font (0-34) according to HPLJ II font list or 99 to print it\n");
    fprintf (stdout, "  g	--	font (0-%d) according to DeskJet font list or 99 to print it\n",NbFontsDJint);
    fprintf (stdout, "   	        (PM: both fonts were written according to the printer font\n");
    fprintf (stdout, "   	        list, but the result here is different. Why?!  !|-(\n");
    fprintf (stdout, "  X,x	--      (number of lines). According to the number of lines given,\n");
    fprintf (stdout, "   	  	it chooses F, G and l. Paper size is set to US legal. Option\n");
    fprintf (stdout, "   	  	x centeres vertically the text adjusting the upper margin\n");
    fprintf (stdout, "  w	--	Send results to standard output\n");
    fprintf (stdout, "  H,?	--	This help\n");
    fprintf (stdout, "*** Final remarks ***\n");
    fprintf (stdout, "1. options X,x and f are hopefully the easiest way to set up the printer\n");
    fprintf (stdout, "2. useful option for program listings:  pm4hp -x72 -{f,g}21 filename,\n");
    fprintf (stdout, "   where f is on HPLJ and g on HPDJ. It makes 132 chars/line. \n");
    fprintf (stdout, "   For even higher vertical compression use      pm4hp -x144 -g17 filename\n");
    fprintf (stdout, "3. Fonts HPDJ enable max. chars/line: 96 (fonts g0..g10), 133 (g11..g19),\n");
    fprintf (stdout, "   160 (20..23)\n");
    fprintf (stdout, "4. redirection of output from printer to file:  pm4hp -options -w file >output_file\n");
}

static char *Symbols[] =
{
    "\033(8U",			/* Roman-8 */
    "\033(0U",			/* USASCII */
    "\033(0E",			/* Roman Ext. */
    "\033(0D",			/* Danish/Norwegian */
    "\033(1E",			/* United Kingdom */
    "\033(0F",			/* French */
    "\033(0G",			/* German */
    "\033(0I",			/* Italian */
    "\033(0S",			/* Swedish/Finnish */
    "\033(1S",			/* Spanish */
    "\033(1U",			/* Legal */
    "\033(0B",			/* Line Draw */
    "\033(8M",			/* Math8 */
    "\033(0Q",			/* Math8a */
    "\033(1Q",			/* Math8b */
    "\033(0M",			/* Math7 */
    "\033(15U",			/* PiFont */
    "\033(2Q",			/* PiFonta */
    0
};

static char *Spacing[] =
{
    "\033(s1P",			/* Proportional */
    "\033(s0P",			/* Fixed */
    0
};

static char *Type[] =
{				/* Yes I know their not in order... */
    "\033(s3T",			/* Courier (default) */
    "\033(s0T",			/* Line Printer */
    "\033(s4T",			/* Helvetica */
    "\033(s5T",			/* Times Roman */
    "\033(s8T",			/* Prestige Elite */
    "\033(s6T",			/* Gothic */
    "\033(s1T",			/* Pica */
    "\033(s7T",			/* Script */
    "\033(s9T",			/* Caslon */
    "\033(s10T",		/* Orator */
    0
};

static char *Orientation[] =
{
    "\033&l0O",			/* Portrait */
    "\033&l1O",			/* Landscape */
    0
};

static char *Point[] =
{
    "\033(s7V",			/* 7 Pt. */
    "\033(s8V",			/* 8 Pt. */
    "\033(s8.5V",		/* 8.5 Pt. */
    "\033(s10V",		/* 10 Pt. */
    "\033(s12V",		/* 12 Pt. */
    "\033(s14.4V",		/* 14.4 Pt */
    0
};

static char *Pitch[] =
{
    "\033(s10H",		/* 10 CPI */
    "\033(s12H",		/* 12 CPI */
    "\033(s16.6H",		/* 16.66 CPI */
    "",				/* no pitch for proportional spacing */
    0
};

static char *Lpi[] =
{
    "\033&l7.27c",		/* 66 lines per page with 1/2 at top and
				   bot */
    "\033&l1D",		/* 1 lpi */
    "\033&l2D",		/* 2 lpi */
    "\033&l3D",		/* 3 lpi */
    "\033&l4D",		/* 4 lpi */
    "\033&l6D",		/* 6 lpi */
    "\033&l8D",		/* 8 lpi */
    "\033&l12D",		/* 12 lpi */
    "\033&l16D",		/* 16 lpi */
    "\033&l24D",		/* 24 lpi */
    0
};

static char *Italic = "\033(s1S";

static char *Bold = "\033(s3B";

/* +++ */
static char *PaperFormatStr[] =
{
    "\033&l0A",   /* default */
    "\033&l2A",   /* US letter */
    "\033&l3A",   /* US legal */
    "\033&l1A",   /* US exe */
    "\033&l26A",  /* A4 */
    "\033&l-81A", /* envelope 10 */
    "\033&l-90A", /* envelope DL */
    0
};

static char *FontHPLJ[] = {
  "\033(11U\033(s0p10.00h12.0v0s0b3T\033&l0O",  /* PC-8 */
  "\033(11U\033(s0p16.67h8.5v0s0b0T\033&l0O",
  "\033(11U\033(s0p12.00h10.0v0s0b3T\033&l0O",
  "\033(11U\033(s0p12.00h10.0v0s3b3T\033&l0O",
  "\033(11U\033(s0p12.00h10.0v1s0b3T\033&l0O",  /* 4 */
  "\033(11U\033(s0p10.00h12.0v0s3b3T\033&l0O",
  "\033(11U\033(s0p10.00h12.0v1s0b3T\033&l0O",
  "\033(8U\033(s0p16.67h8.5v0s0b0T\033&l0O",   /* ROMAN-8 */
  "\033(8U\033(s0p12.00h10.0v0s0b3T\033&l0O",  /* 8 */
  "\033(8U\033(s0p12.00h10.0v0s3b3T\033&l0O",
  "\033(8U\033(s0p12.00h10.0v1s0b3T\033&l0O",
  "\033(8U\033(s0p10.00h12.0v0s0b3T\033&l0O",
  "\033(8U\033(s0p10.00h12.0v0s3b3T\033&l0O", /* 12 */
  "\033(8U\033(s0p10.00h12.0v1s0b3T\033&l0O",
  "\033(0N\033(s0p16.67h8.5v0s0b0T\033&l0O",  /* ECMA-94 */
  "\033(0N\033(s0p12.00h10.0v0s0b3T\033&l0O",
  "\033(0N\033(s0p12.00h10.0v0s3b3T\033&l0O", /* 16 */
  "\033(0N\033(s0p12.00h10.0v1s0b3T\033&l0O",
  "\033(0N\033(s0p10.00h12.0v0s0b3T\033&l0O",
  "\033(0N\033(s0p10.00h12.0v0s3b3T\033&l0O",
  "\033(0N\033(s0p10.00h12.0v1s0b3T\033&l0O", /* 20 */
  "\033(10U\033(s0p16.67h8.5v0s0b0T\033&l0O",  /* PC-8 */
  "\033(10U\033(s0p12.00h10.0v0s0b3T\033&l0O",
  "\033(10U\033(s0p12.00h10.0v0s3b3T\033&l0O",
  "\033(10U\033(s0p12.00h10.0v1s0b3T\033&l0O", /* 24 */
  "\033(10U\033(s0p10.00h12.0v0s0b3T\033&l0O",
  "\033(10U\033(s0p10.00h12.0v0s3b3T\033&l0O",
  "\033(10U\033(s0p10.00h12.0v1s0b3T\033&l0O", /* 27 */
  "\033(12U\033(s0p16.67h8.5v0s0b0T\033&l0O",  /* PC-850 */
  "\033(12U\033(s0p12.00h10.0v0s0b3T\033&l0O",
  "\033(12U\033(s0p12.00h10.0v0s3b3T\033&l0O",
  "\033(12U\033(s0p12.00h10.0v1s0b3T\033&l0O", /* 31 */
  "\033(12U\033(s0p10.00h12.0v0s0b3T\033&l0O",
  "\033(12U\033(s0p10.00h12.0v0s3b3T\033&l0O",
  "\033(12U\033(s0p10.00h12.0v1s0b3T\033&l0O",  /* 34 */
  0
};

/* This I've tried according to the HPDJ 560 font list
   but the problems were with Univers style and very
   strange PS option (oh, how I like manuals, mainly
   from HP !
static char *FontHPDJ[] = {
  "\033(10U\033(s0p10.00h12.0v0s0b3T\033&l0O",
  "\033(10U\033(s0p16.67h10.0v0s0b3T\033&l0O",
  "\033(10U\033(s0p20.00h12.0v0s0b3T\033&l0O",
  "\033(10U\033(s0p10.00h12.0v1s0b3T\033&l0O",
  "\033(10U\033(s0p10.00h12.0v0s3b4101T\033&l0O",
  "\033(10U\033(s0p10.00h12.0v1s0b4101T\033&l0O",
  "\033(10U\033(s0p12.00h12.0v0s0b6T\033&l0O",
  "\033(10U\033(s0p12.00h12.0v1s0b6T\033&l0O",
  "\033(10U\033(s0p10.00h14.0v0s3b52T\033&l0O",
  "\033(10U\033(s0p10.00h12.0v1s3b52T\033&l0O",
  "\033(10U\033(s0p10.00h12.0v0s3b52T\033&l0O",
  "\033(10U\033(s0p10.00h10.0v1s0b52T\033&l0O",
  "\033(10U\033(s0p10.00h10.0v0s0b52T\033&l0O",
  "\033(10U\033(s0p14.00h14.0v1s3b4101T\033&l0O",
  "\033(10U\033(s0p14.00h14.0v0s3b4101T\033&l0O",
  "\033(10U\033(s0p16.67h10.0v1s0b4101T\033&l0O",
  "\033(10U\033(s0p16.67h10.0v0s0b4101T\033&l0O",
  "\033(10U\033(s0p16.67h8.0v1s0b4101T\033&l0O",
  "\033(10U\033(s0p16.67h8.0v0s0b52T\033&l0O",
  "\033(10U\033(s0p16.67h8.0v0s0b4101T\033&l0O",
  0
};
*/

/* This I've arranged in the manner I like it. (PM) */
static char *FontHPDJ [NbFontsDJ] = {
  "\033(10U\033(s0p10.00h12.0v0s0b3T\033&l0O",
  "\033(10U\033(s0p10.00h12.0v1s0b3T\033&l0O",
  "\033(10U\033(s0p10.00h12.0v0s3b4101T\033&l0O",
  "\033(8U\033(s0p10.00h12.0v1s0b4101T\033&l0O",
  "\033(10U\033(s0p12.00h12.0v0s0b6T\033&l0O",
  "\033(10U\033(s0p12.00h12.0v1s0b6T\033&l0O",
  "\033(10U\033(s0p10.00h14.0v0s3b52T\033&l0O",
  "\033(8U\033(s0p10.00h12.0v1s3b52T\033&l0O",
  "\033(10U\033(s0p10.00h10.0v0s3b52T\033&l0O",
  "\033(10U\033(s0p10.00h10.0v1s0b52T\033&l0O",
  "\033(10U\033(s0p10.00h10.0v0s0b52T\033&l0O", /* 10 */
  "\033(10U\033(s0p16.67h10.0v0s0b3T\033&l0O",
  "\033(10U\033(s0p14.00h14.0v1s3b4101T\033&l0O",
  "\033(10U\033(s0p14.00h14.0v0s3b4101T\033&l0O",
  "\033(10U\033(s0p16.67h10.0v1s0b4101T\033&l0O",
  "\033(10U\033(s0p16.67h10.0v1s3b4101T\033&l0O", /* 15 */
  "\033(10U\033(s0p16.67h10.0v1s0b4101T\033&l0O",
  "\033(10U\033(s0p16.67h8.0v1s0b4101T\033&l0O",
  "\033(10U\033(s0p16.67h8.0v0s0b52T\033&l0O",
  "\033(10U\033(s0p20.00h12.0v1s0b3T\033&l0O"
  "\033(10U\033(s0p20.00h12.0v0s3b3T\033&l0O"
  "\033(10U\033(s0p20.00h12.0v1s3b3T\033&l0O"
  "\033(10U\033(s0p20.00h12.0v0s3b3T\033&l0O"
  "\033(10U\033(s0p16.67h8.0v0s0b4101T\033&l0O",
  "\033(10U\033(s0p16.67h8.0v0s0b4101T\033&l0O",
  "\033(10U\033(s0p20.00h12.0v0s0b3T\033&l0O",
  "\033(10U\033(s0p20.00h12.0v1s0b3T\033&l0O",
  "\033(10U\033(s0p20.00h12.0v0s3b3T\033&l0O",
  "\033(10U\033(s0p20.00h12.0v1s3b3T\033&l0O",
  };


#ifdef PRINTERSTATUS
void PrinterStatus (void) {
/* my old turbo pascal code:
   const E: array [0..3] of string [22]=('OK','Printer is not ready','No paper','Printer is OFF-line');
   var I,K: byte; Reg: registers;
  reg.ah:=2; reg.dx:=0; Intr($17,reg); i:=reg.ah;
  if (i and 64)=64 then k:=1
  else if (i and 32)=32 then k:=2
       else if (i and  8)=8 then k:=3
	 else k:=0;
  PrinterStatus:=E[k] */

struct REGPACK reg; unsigned int i;
reg.r_ax = 2 << 8;
reg.r_dx = 0;
intr(0x17, &reg);
i=(reg.r_ax >>8);
/* this is not working today, but yesterday it was. Oh, why?
   if ( i & 0x68)
     { fprintf(stdout,"printer is not ready.\n"); exit(1); }
*/
if (i==0 || i==3 || i==128 || i==200)
  { fprintf(stdout,"printer is not ready.\n"); exit(1); }
}
#endif

/* +++--------------- */

#define		CTRL(c)		('c' & 037)

/*
 *  Defaults
 */

int     sym = 1;
int     type = 0;
int     spc = 1;
int     orient = 0;
int     ps = 3;
int     ptch = 0;
int     lpi = 0;
int     offset = 0;
int     stdoutput = 0;
int     pagestep = 8;
int     forms = 72;
int     italic = 0;
int     bold = 0;
int     Debug = 0;


/*       ************ MAIN ***************  */


int main (argc, argv)
int     argc;
char   *argv[];
{
    FILE * fp, *fopen ();
    extern char *optarg;
    extern int  optind;
    int     i,
	    c,
	    errflg = 0;

    if (argc==1) { USAGE(); exit(1); }
    while ((c = getopt (argc, argv, "c:o:t:h:l:s:p:O:P:F:G:d:f:g:A:X:x:U:biH?wWDerR")) != EOF) {
	switch (c) {
	    case 'D':
		++Debug;
		break;

	    case 'l':
		lpi = atoi (optarg);
		switch (lpi) {
		    case 1: 
		    case 2:
		    case 3: 
		    case 4:
		    case 6:
		    case 8: 
		    case 12:
		    case 16: 
		    case 24:
			if (Debug)
			    fprintf (stdout, "lpi = %d, ", lpi);
			break;
		    default:
			printf ("Lines Per Inch values must be one of 1, 2, 3, 4, 6, 8, 12, 16, or 24.\n");
			USAGE ();
			exit (1);
		}
		break;
	    case 'o': 
		if (*optarg == 'p' || *optarg == 'P')
		    orient = 0;
		else
		    if (*optarg == 'l' || *optarg == 'L')
			orient = 1;
		    else {
			printf ("Orientation must be specified as either 'P' or 'L'.\n");
			USAGE ();
			exit (1);
		    }
		if (Debug)
		    fprintf (stdout, "orientation -> %c, ", *optarg);
		break;

	    case 't':
		type = atoi (optarg);
		--type;
		if (type < 0 || type > 10) {
		    printf ("Typeface selection must be in the range of 1 (one) to 6 (six).\n");
		    USAGE ();
		    exit (1);
		}
	    /* Set up some defaults in case none of these are chosen
	       explicitly */
		switch (type) {
		    case 0: 
			sym = orient = ptch = 0;
			spc = 1;
			ps = 4;
			break;
		    case 1: 
			sym = spc = 1;
			orient = 0;
			ps = ptch = 2;
			break;
		    case 2:
			sym = spc = 0;
			orient = 1;
			ps = ptch = 3;
			break;
		    case 3:
			sym = spc = orient = 0;
			ps = 4;
			ptch = 1;
			break;
		    case 4:
			sym = orient = 0;
			spc = 1;
			ps = 3;
			ptch = 1;
			break;
		    case 5:
			sym = orient = 0;
			spc = 1;
			ps = 4;
			ptch = 1;
			break;
		    case 6:
			sym = orient = 0;
			spc = ptch = 1;
			ps = 4;
			break;
		}
		if (Debug)
		    fprintf (stdout, "typeface = %d, ", type);
		break;

	    case 's':
		if (*optarg == 'P' || *optarg == 'p') {
		    spc = 0;
		    ptch = 3;
		}
		else
		    if (*optarg == 'F' || *optarg == 'f')
			spc = 1;
		    else {
			printf ("Spacing must be specified as either 'P' or 'F'\n");
			USAGE ();
			exit (1);
		    }
		if (Debug)
		    fprintf (stdout, "spacing -> %c, ", *optarg);
		break;

	    case 'h':
		ps = atoi (optarg);
		--ps;
		if (ps < 0 || ps > 6) {
		    printf ("Point size must be specified within the range of 1 (one) to 6 (six)\n");
		    USAGE ();
		    exit (1);
		}
		if (Debug)
		    fprintf (stdout, "point size = %d, ", ps);
		break;

	    case 'p': 
		ptch = atoi (optarg);
		--ptch;
		if (ptch < 0 || ptch > 3) {
		    printf ("Pitch must be specified within the range of 1 (one) to 6 (six).\n");
		    USAGE ();
		    exit (1);
		}
		if (Debug)
		    fprintf (stdout, "pitch = %d, ", ptch);
		break;

	    case 'c': 		/* Symbol Set selection */
		sym = atoi (optarg);
		--sym;
		if (sym < 0 || sym > 18) {
		    printf ("Character set selection must be between the range of 1 (one) and 18 (eighteen).\n");
		    USAGE ();
		    exit (1);
		}
		if (Debug)
		    fprintf (stdout, "symbol set = %d, ", sym);
		break;

	    case 'O': 		/* Offset from left margin */
		offset = atoi (optarg);
		if (offset < 0 || offset > 80) {
		    printf ("Offset value must be specified between the range of 0 (zero) and 80 (eighty).\n");
		    USAGE ();
		    exit (1);
		}
		if (Debug)
		    fprintf (stdout, "offset = %d, ", offset);
		break;

	    case 'P':
		pagestep = atoi (optarg);
		if (pagestep < 0 || pagestep > 66) {
		    printf ("Page Step value must be specified between the range of 1 (one) and 66 (sixty six).\n");
		    USAGE ();
		    exit (1);
		}
		if (Debug)
		    fprintf (stdout, "page step = %d, ", pagestep);
		break;

	    case 'F':
		forms = atoi (optarg);
		if (forms < 0) {
		    printf ("Lines of text one page (forms) must be greater than 0.\n");
		    USAGE ();
		    exit (1);
		}
		if (Debug)
		    fprintf (stdout, "forms = %d, ", forms);
		break;

	    case 'i':
		italic++;
		if (Debug)
		    fprintf (stdout, "italics set, ");
		break;

	    case 'b':
		bold++;
		if (Debug)
		    fprintf (stdout, "bold set, ");
		break;

	    case 'w': 		/* Standard Output */
		if (Debug)
		    fprintf (stdout, "results to stdout, ");
		stdoutput++;
		break;

	    case 'H': case '?':
		HELP ();
		exit (1);

/* +++++++++++++++++++++++++++ */
	    case 'G':
		linespage = atoi (optarg);
		if (linespage<0) {
		    printf ("Number of lines on page cannot be negative.\n");
		    USAGE ();
		    exit (1);
		}
		if (Debug)
		    fprintf (stdout, "linespage = %d, ", linespage);
		break;
	    case 'U':
		UpperMargin = atoi (optarg);
		if (UpperMargin<0) {
		    printf ("Upper margin cannot be negative.\n");
		    USAGE ();
		    exit (1);
		}
		if (Debug)
		    fprintf (stdout, "UpperMargin = %d, ", UpperMargin);
		break;
	    case 'd':
		pmd = atoi (optarg);
		switch (pmd) {
		    case 0:
		    case 1:
		    case 2:
			if (Debug)
			    fprintf (stdout, "pmd = %d, ",pmd);
			break;
		    default:
			fprintf (stdout,"Direction must be one of 0, 1 or 2.\n");
			USAGE ();
			exit (1);
		}
		break;
	    case 'f':
		pmg = -1;
		pmf = atoi (optarg);
		if (pmf==99) { /* print fonts */
			ShowFonts=1; UpperMargin=3;
			linespage=forms=60; lpi=4; } else {
		if (!((pmf>=0)&&(pmf<=34))) {
		  fprintf (stdout,"Font number must be from 0 to 34.\n");
		  USAGE ();
		  exit (1); };
		if (Debug)
		  fprintf (stdout, "pmf = %d, ", pmf); }
		break;
	    case 'g':
		pmf = -1;
		pmg = atoi (optarg);
		if (pmg==99) { /* print fonts */
			ShowFontsDeskJet=1; UpperMargin=3;
			linespage=forms=60; lpi=4; } else {
		if (!((pmg>=0)&&(pmg<=NbFontsDJ))) {
		  fprintf (stdout,"Font number must be from 0 to %d.\n",NbFontsDJ);
		  USAGE ();
		  exit (1); };
		if (Debug)
		  fprintf (stdout, "pmg = %d, ", pmg); }
		break;
	    case 'A':
		PaperFormat = atoi (optarg);
		if (!((PaperFormat>=0)&&(PaperFormat<=6))) {
		  fprintf (stdout,"Paper format must be from 0 to 6.\n");
		  USAGE ();
		  exit (1); };
		if (Debug)
		  fprintf (stdout, "PaperFormat= %d, ", PaperFormat);
		break;
	    case 'X': case 'x':
		tmpXx = atoi (optarg);
		if (tmpXx<=0) {
		  fprintf (stdout,"Number of lines must be positive.\n");
		  USAGE ();
		  exit (1); };
		if (Debug)
		  fprintf (stdout, "tmpXx = %d, ", tmpXx );
		forms=linespage=tmpXx;
		PaperFormat=2;
		if (tmpXx>284) fprintf(stdout,"Cannot set lpi greater than 24 (284 lines/page).\n");
		if (tmpXx>192) lpi=24; else
		if (tmpXx>144) lpi=16; else
		if (tmpXx>96) lpi=12; else
		if (tmpXx>72) lpi=8; else
		if (tmpXx>48) lpi=6; else
		if (tmpXx>36) lpi=4; else
		if (tmpXx>24) lpi=3; else
		if (tmpXx>12) lpi=2; else
		if (tmpXx>0) lpi=1;
		if (c=='x') UpperMargin= (12*lpi-tmpXx)/2;
		 /* G is incremented below */
		break;
	    case 'e': Eject=0; break;
	    case 'r': BeforeFileReset=0; break;
	    case 'R': FinalReset=1; break;

/* +++++++++++++-------------- */

	    default:
		errflg++;
		break;
	}
    }

    if (errflg) {
	fprintf (stdout, "pm4hp  [ - {options} ]  [ files ] ... \n");
	USAGE ();
	exit (1);
    }

    if (Debug)
	fprintf (stdout, "\b \n");

    if (argc == optind)
	sendjob (NULL);
    else
	for (; optind < argc; optind++)
	    if ((fp = fopen (argv[optind], "r")) == NULL) {
		fprintf (stdout, "pm4hp: can't open %s\n", argv[optind]);
		exit (1);
	    }
	    else {
		sendjob (fp);
		fclose (fp);
	    }
    exit (0);
return 0;
}

sendjob (fp)
FILE * fp;
{
    FILE * pp, *open ();
    int     pg = pagestep,
	    c,
	    lines;

    if (!stdoutput) {
#ifdef PRINTERSTATUS
	PrinterStatus ();
#endif
	if ((pp = fopen ("prn", "w")) == NULL) {
	    fprintf (stdout, "pm4hp: printer error.\n");
	    exit (1);
	}
    }
    else
	pp = stdout;

#ifdef PRINTERSTATUS
   PrinterStatus ();
#endif
   if (ferror(pp))
     { fprintf (stdout,"pm4hp: error on printer (maybe not ready).\n"); exit(1); }

/* PM+ */
/* forms: maximal number of lines per page,
   linespage: nb of lines to be printed on page */
/*  if (linespage!=9999 || forms!=9999)
    if (linespage>forms) forms=linespage;
let everybody take the responsability for F>=G
*/
/* NOT:  so change it
    if (forms!=9999 && lpi==0) {
	lpi=24*forms/146;
	if (lpi<=1) lpi=1; else if (lpi>4)
	if (lpi<=6) lpi=6; else
	if (lpi<=8) lpi=8; else
	if (lpi<=12) lpi=12; else
	if (lpi<=16) lpi=16; else
	  lpi=24;
	};
*/
/* PM- */
if (BeforeFileReset)
  fprintf (pp,"\033E"); /* make reset before start */
if (pmd>=0) fprintf (pp, "\033&k%dW", pmd);
if (orient>=0) fprintf (pp, Orientation[orient]);
if (PaperFormat>=0 && PaperFormat<=6) fprintf (pp, PaperFormatStr[PaperFormat]);
/* now can be support format: default, letter, A4, envelope */
if (lpi>0) fprintf (pp,"\033&l%dD",lpi); /* lines/inch &l#D */    /* cannot: Lpi[lpi]! */
if (linespage>0 && linespage!=9999)
  fprintf (pp, "\033&l%dP", linespage+UpperMargin);
    /* lines per page corrected to the shift by UpperMargin */
/*    fprintf (pp, "\033&l1L"); why to make skipping active? */
fprintf (pp, "\033&l%dE",UpperMargin); /* upper margin set to this number */
if (forms!=9999 && forms>=0) fprintf (pp, "\033&l%dF", forms); /* text lines on page */
if (offset) fprintf (pp, "\033&a%dL", offset); /* left lateral margin */
/* now can be text reduction mode (?) */
if (pmf==-1 && !ShowFonts && !ShowFontsDeskJet) {
  if (sym>=0) fprintf (pp, "%s",Symbols[sym]); /* Roman-8, USASCII etc. */
  if (spc>=0) fprintf (pp, "%s",Spacing[spc]); /* proport/fixed */
  if (ptch>=0) fprintf (pp,"%s",Pitch[ptch]); /* horizont. H 10,12,16.66 */
  if (ps>=0)  fprintf (pp, "%s",Point[ps]); /* char height V in points */
  if (italic) fprintf (pp, "%s", Italic); /* Style: Roman/Italic */
  if (bold) fprintf (pp, "%s", Bold); /* Bold/Normal/ExtraBold */
  if (Type>=0) fprintf (pp, "%s",Type[type]); /* Courier, line printer etc. (s#T */
  };

if (pmf>=0 && pmf<=34 && !ShowFonts)
  fprintf (pp, FontHPLJ[pmf]);
if (pmg>=0 && pmg<=NbFontsDJ && !ShowFontsDeskJet)
  fprintf (pp, FontHPDJ[pmg]);

if (ShowFonts || ShowFontsDeskJet) { int kk,kkk, kend;
  fprintf (pp,"****** PM4HP");
  if (ShowFonts) { fprintf(pp,"LJ"); kend=34; }
    else { fprintf(pp,"DJ"); kend=NbFontsDJ-1; }
  fprintf(pp," FONT LIST produced by program pm4hp ******\n\n");
  for (kk=0; kk<=kend; kk++) {
    if (ShowFonts) fprintf (pp, "%s", FontHPLJ[kk]);
      else fprintf(pp,"%s",FontHPDJ[kk]);
    fprintf (pp, "font %d:",kk);
    for (kkk=32; kkk<=127; kkk++)
      fprintf(pp,"%c",kkk);
    fprintf(pp,"\n");
    };
  fprintf(pp,"\f\033E");
  fclose (pp);
  exit(0); };

/* +++++---- */


    if (fp!=NULL) /* PM */
    while ((c = getc (fp)) != EOF) {
	if (c == CTRL (l)) {
	    while (lines < forms) {
		putc ('\n', pp);
		lines++;
	    }
	    continue;		/* eat the ^L char */
	}
	if (c == CTRL (j)) {
	    if (lines == forms) {
		while (pg-- > 0)
		    putc ('\n', pp);
		lines = 0;
		continue;
	    }
	    else
		lines++;
	}
	putc (c, pp);
    }
if (FinalReset) /* reset the printer to default settings */
    fprintf (pp, "\033E");
if (Eject) fprintf (pp,"\f");
fclose (pp);
return 0;
}

/* end of file pm4hp.c */
